<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="身份证号" prop="fIdNo">
        <el-input
          v-model="queryParams.fIdNo"
          placeholder="请输入身份证号"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <!--<el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
        >删除</el-button>
      </el-col>-->
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
		      :loading="exportLoading"
          @click="handleExport"
        >导出</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          plain
          size="mini"
          type="info"
          @click="getGovermentTaskInfo"
        >从省平台获取数据</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="browseList">
      <el-table-column label="身份证号" align="center" prop="fIdNo" />
      <el-table-column label="专家表现评价" align="center" prop="fExperEval" :show-overflow-tooltip="true"/>
      <el-table-column label="选用事件" align="center" prop="fSelectionEvent" :show-overflow-tooltip="true"/>
      <el-table-column label="选用开始时间" align="center" prop="fSelectionStartTime" />
      <el-table-column label="评分说明" align="center" prop="fScorDesc" :show-overflow-tooltip="true"/>
      <el-table-column label="最后修改时间" align="center" prop="fUpdateTime" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-document"
            @click="handleDetail(scope.row)"
          >详情</el-button>
          <!--<el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
          >删除</el-button>-->
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改行业专家库-专家行为浏览对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="身份证号" prop="fIdNo">
          <el-input v-model="form.fIdNo" placeholder="请输入身份证号" />
        </el-form-item>
        <el-form-item label="专家表现评价" prop="fExperEval">
          <el-input v-model="form.fExperEval" placeholder="请输入专家表现评价" />
        </el-form-item>
        <el-form-item label="选用事件" prop="fSelectionEvent">
          <el-input v-model="form.fSelectionEvent" placeholder="请输入选用事件" />
        </el-form-item>
        <el-form-item label="选用开始时间" prop="fSelectionStartTime">
          <el-input v-model="form.fSelectionStartTime" placeholder="请输入选用开始时间" />
        </el-form-item>
        <el-form-item label="评分说明" prop="fScorDesc">
          <el-input v-model="form.fScorDesc" placeholder="请输入评分说明" />
        </el-form-item>
        <el-form-item label="最后修改时间" prop="fUpdateTime">
          <el-input v-model="form.fUpdateTime" placeholder="请输入最后修改时间" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <!-- 详情 -->
    <DetailInfo ref="detail"/>
  </div>
</template>

<script>
import {
  listBrowse,
  getBrowse,
  delBrowse,
  addBrowse,
  updateBrowse,
  exportBrowse,
  getProBehInforBrowseTask
} from "@/api/specialist/behBrowse";
import DetailInfo from "./components/DetailInfo";
import {getExpertDeclarationTask} from "@/api/specialist/browse";
import moment from "moment/moment";
export default {
  name: "Browse",
  components: {
    DetailInfo
  },
  data() {
    return {
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 行业专家库-专家行为浏览表格数据
      browseList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        fIdNo: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        fIdNo: [
          { required: true, message: "身份证号不能为空", trigger: "blur" }
        ],
        fExperEval: [
          { required: true, message: "专家表现评价不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询行业专家库-专家行为浏览列表 */
    getList() {
      this.loading = true;
      listBrowse(this.queryParams).then(response => {
        this.browseList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        fProBehInforId: null,
        fIdNo: null,
        fExperEval: null,
        fSelectionEvent: null,
        fSelectionStartTime: null,
        fScorDesc: null,
        fUpdateTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.fProBehInforId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加行业专家库-专家行为浏览";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const fProBehInforId = row.fProBehInforId || this.ids
      getBrowse(fProBehInforId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改行业专家库-专家行为浏览";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.fProBehInforId != null) {
            updateBrowse(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addBrowse(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const fProBehInforIds = row.fProBehInforId || this.ids;
      this.$confirm('是否确认删除行业专家库-专家行为浏览编号为"' + fProBehInforIds + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delBrowse(fProBehInforIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有行业专家库-专家行为浏览数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportBrowse(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    },
    //获取数据
    getGovermentTaskInfo(){
      this.$confirm('是否确认从省平台获取数据?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function() {
        return getProBehInforBrowseTask({updateTime:moment().format('YYYY-MM-DD HH:mm:ss'),pageIndex: 1,pageSize: 1000});
      }).then(() => {
        this.getList();
        this.msgSuccess("从省平台获取数据成功");
      }).catch(() => {});
    },
    //详情
    handleDetail(row){
      this.$refs.detail.getDetailInfo(row.fProBehInforId);
    },
  }
};
</script>
